Drupal.behaviors.comment_easy_reply = function (context, settings) {
    $('.comment-easy-reply-number-link-wrapper:not(.comment-easy-reply-processed)', context).each(function () {
      $(this).addClass('comment-easy-reply-processed');
      var tips = $(this).children('.comment-easy-reply-number-link-tips');
      var link = $(this).children('.comment-easy-reply-number-link');
      link.hover(function () {
        tips.show();
        Drupal.comment_easy_reply.init_tips(link,tips);
      },
      function () {
        tips.hide();
      });
      if(Drupal.settings.comment_easy_reply && Drupal.settings.comment_easy_reply.user_can_reply){
        link.click(function () {
          var classes=$(this).attr('class').split(/\s+/);
          var commentnumber = 0;
          var definedclass = 'comment-easy-reply-linknum-';
          for (i = 0; i < classes.length; i++) {
             if(classes[i].length > 0 && classes[i].substr(0,definedclass.length)==definedclass){
               commentnumber = classes[i].substr(definedclass.length,classes[i].length);
               break;
             }
          }
          if(commentnumber!='undefined'){
            var newvalue = "@#"+commentnumber+" ";
            Drupal.comment_easy_reply.insertContent(newvalue);
          }
          $('html,body').animate({scrollTop: $("#edit-comment").offset().top});
          return false;
        });
      }
    });
    $('.comment-easy-reply-referrer-link-wrapper:not(.comment-easy-reply-processed)', context).each(function () {
      $(this).addClass('comment-easy-reply-processed');
      var tips = $(this).children('.comment-easy-reply-referrer-link-hover');
      var link = $(this).children('.comment-easy-reply-number-link');
      link.hover(function () {
        tips.show();
        Drupal.comment_easy_reply.init_tips(link,tips);
      },
      function () {
        tips.hide();
      }).click(function () {
        return false;
      });
    });
    if(Drupal.settings.comment_easy_reply != 'undefined' && Drupal.settings.comment_easy_reply.form_location=='below'){
      $('.comment_reply:not(.comment-easy-reply-processed)', context).each(function () {
        $(this).addClass('comment-easy-reply-processed');
        $(this).children('a').click(function () {
          var classes=$(this).attr('class').split(/\s+/);
          var commentnumber = 0;
          var definedclass = 'comment-easy-reply-number-';
          for (i = 0; i < classes.length; i++) {
             if(classes[i].length > 0 && classes[i].substr(0,definedclass.length)==definedclass){
               commentnumber = classes[i].substr(definedclass.length,classes[i].length);
               break;
             }
          }
          if(commentnumber != 'undefined'){
            var oldvalue = $('#edit-comment').val();
            oldvalue += "@#"+commentnumber+" ";
            $('#edit-comment').val(oldvalue);
          }
          $('html,body').animate({scrollTop: $("#edit-comment").offset().top});
          return false;
        });
      });
    }
  if(Drupal.settings.comment_easy_reply != 'undefined' && Drupal.settings.comment_easy_reply.comment_mode != 'undefined'){
    if(Drupal.settings.comment_easy_reply.comment_mode==1 || Drupal.settings.comment_easy_reply.comment_mode==3){
      $('.comment-folded:not(.comment-easy-reply-processed)', context).each(function () {
        $(this).addClass('comment-easy-reply-processed');
        var body = $(this).children('.body');
        $(this).children('.subject a').click(function () {
          $(this).toggleClass('open');
          body.toggle();
          return false;
        });
      });
    }
  }
};
Drupal.comment_easy_reply = {
  insertContent: function(newvalue){
    var textareaid = 'edit-comment';
    // WYSIWYG support.
    if (Drupal.wysiwyg && Drupal.wysiwyg.activeId) {
      Drupal.wysiwyg.instances[Drupal.wysiwyg.activeId].insert(newvalue)
    }
    // CKeditor module support.
    else if (typeof(CKEDITOR) != 'undefined' && CKEDITOR.instances[textareaid]) {
      CKEDITOR.instances[textareaid].insertHtml(newvalue);
    }
    // TinyMCE module support.
    else if (typeof(tinyMCE) != 'undefined' && tinyMCE.activeEditor) {
      tinyMCE.activeEditor.execCommand('mceInsertContent', false, newvalue);
    }
    // FCKeditor module support.
    else if (typeof(FCKeditorAPI) != 'undefined' && typeof(fckActiveId) != 'undefined') {
      FCKeditorAPI.Instances[fckActiveId].InsertHtml(newvalue);
    }
    // No editor found, go for plain textarea.
    else {
      var editor = document.getElementById(textareaid);
      var oldvalue = editor.value;
      if (document.selection) {
        editor.focus();
        sel = document.selection.createRange();
        sel.text = newvalue;
        editor.focus();
      }
      else if (editor.selectionStart || editor.selectionStart == '0') {
        var startPos = editor.selectionStart;
        var endPos = editor.selectionEnd;
        var scrollTop = editor.scrollTop;
        editor.value = editor.value.substring(0, startPos)+newvalue+editor.value.substring(endPos,editor.value.length);
        editor.focus();
        editor.selectionStart = startPos + newvalue.length;
        editor.selectionEnd = startPos + newvalue.length;
        editor.scrollTop = scrollTop;
      } else {
        editor.value += myValue;
        editor.focus();
      }
    }
  },
  init_tips: function(link,tips){
    if ($(window).width() < tips.outerWidth() * 1.5){
      tips.css('max-width', $(window).width() / 2);
    }
    else {
      tips.css({'min-width':'200px', 'max-width':'340px'});
    }
    var pos_left = link.position().left - (tips.outerWidth() / 2);
    var pos_top = link.position().top- tips.outerHeight();
    tips.css({'left': pos_left, 'top': pos_top-20}).offset({'left': pos_left, 'top': pos_top-20});
  }
};
